The following repository contains a tensorflow implementation for the differentiable throughput model described in the paper:

**A Differentiable Throughput Model for Load-Aware Cellular Network Optimization through Gradient Descent**

submitted for publication in IEEE Access. In contrast to the use case presented in the paper, the reference implementation 
only considers a single carrier frequency, and does not incorporate external interference. 
We invite interested readers to adapt the model to their requirements, but intentionally limit the implementation to a simple scenario for clarity.

The repository consists of the following components:
*  The tensorflow implementation of the throughput model itself is provided in `throughput_model.py`
*  The `helpers` folder contains the differentiable mappings derived from the monitoring data 

Additionally an illustrative example for transmit power optimization for a randomly generated network deployment is provided in `run_scenario.py`.
Upon execution the computed throughput and other metrics are compared before and after the optimization procedure. 